import nodeResolve from "rollup-plugin-node-resolve";
import commonjs from "rollup-plugin-commonjs";
import json from "rollup-plugin-json";
import babel from "rollup-plugin-babel";

export default {
    input: "src/cli.js",
    external: ["request-promise", "path", "fs", "chalk", "inquirer", "minimist", "os"],
    output: {
        file: "bundle.js",
        format: "cjs",
        globals: {
            "request-promise": "rp",
        },
        banner: "#!/usr/bin/env node\n/* Generated by rollup. Written by John Schmidt */",
        name: "RallyTools",
        sourcemap: true,
    },
    plugins: [
        nodeResolve({
            preferBuiltins: true,
            module: true,
            //jsnext: true,
        }),
        commonjs({
            include: "node_modules/**",
            extensions: [".js"],
        }),
        json(),
        babel({
            presets: [
                ["env", {
                    "targets": {
                        "node": "10.0.0",
                    },
                    "modules": false,
                }]
            ],
            plugins: [
                "transform-decorators-legacy",
                "transform-object-rest-spread",
                "external-helpers"
            ],
        }),
        //builtins(),
    ],
}
